'''
1. После запуска предлагает пользователю ввести неотрицательные целые числа,
разделенные через пробел и ожидает ввода от пользователя.
2. Находит наименьшее положительное число, не входящее в данный пользователем
список чисел и печатает его. После чего ждет следующего ввода.
3. При получении в качестве вводных данных 'cancel' завершает свою работу.

*дополнительно:
Оцените вычислительную сложность решения и аргументируйте.
Постарайтесь придумать решение, работающее за линейное время.

Например:

-> 2 1 8 4 2 3 5 7 10 18 82 2
6
'''

while True:
    print('Введите неотрицательные целые числа:')
    message = [str(i) for i in input().split()]
    if message[0] == 'cancel':
        print('Bye!')
        break
    else:
        s = set()
        for i in range(0, len(message)):
            s.add(int(message[i]))
        k = 1
        while True:
            if k in s:
                k += 1
            else:
                print(k)
                break
